2010-06-01  Werner Koch  <wk@g10code.com>

	* longlong.h (umul_ppmm) <__mips__>: Add code for gcc 4.4.  This
	fixes bug#1231.

2009-12-09  Werner Koch  <wk@g10code.com>

	* config.links: Remove asm modules for all sparc64.  This is
	related to debian#560028.

2008-03-25  Werner Koch  <wk@g10code.com>

	* config.links (mpi_sflags): Powerpc64 needs to come even before
	the generic linux powerpc entry.

2007-10-23  Werner Koch  <wk@g10code.com>

	Switched entire package to GPLv3+.
	* longlong.h: Change address notice but keep LGPL.
	* powerpc32/*: Remove LGPL license cruft in the middle of the
	files

2007-01-15  David Shaw  <dshaw@jabberwocky.com>

	* config.links: powerpc64* needs to come before powerpc* or it
	will never match.  Reported by Alon Bar-Lev for libgcrypt, but
	relevant here as well.

2006-12-11  Werner Koch  <wk@g10code.com>

	* mpi-internal.h: Include mpi-asm-defs.h.
	(mpi_limb_t): Moved definition from mpi.h to here.
	(struct gcry_mpi): Moved from mpi.h to here.
	* mpiutil.c (mpi_get_nlimbs, mpi_is_neg): New.  To replace the
	macros.  This helps hiding details of the MPI implementation.
	(mpi_nlimb_hint_from_nbytes, mpi_nlimb_hint_from_nbits): Ditto.
	(mpi_get_flags): Ditto.
	* mpicoder.c (mpi_read, mpi_read_from_buffer, mpi_print):
	s/MPI_NULL/NULL/.

2005-09-01  David Shaw  <dshaw@jabberwocky.com>

	* mpicoder.c (mpi_read): Fix minor bug in reading a zero-length
	MPI (was failing unnecessarily).

2005-05-06  Werner Koch  <wk@g10code.com>

	* mpi-scan.c (mpi_putbyte, mpi_getbyte): Removed.  Not used.

2005-04-21  Werner Koch  <wk@g10code.com>

	* mpicoder.c (mpi_read): Changed error detection to always return
	an error while maintaining the actual number of bytes read.

2005-03-11  Werner Koch  <wk@g10code.com>

	* Makefile.am (ASFLAGS): Renamed to AM_CCASFLAGS and added the
	variable for non exectubale stack options.  Adapted users.

2004-12-20  Werner Koch  <wk@g10code.com>

	* mpicoder.c (mpi_read_from_buffer): Don't abort in case of an
	invalid MPI but print a message and return NULL.  Use log_info and
	not log_error.

2004-10-26  Werner Koch  <wk@g10code.com>

	* config.links: Use HOST instead of TARGET.

2004-10-12  Werner Koch  <wk@g10code.com>

	* Makefile.am (.S.o): Include MPI_SFLAGS. This is our bug 145.

2004-09-29  David Shaw  <dshaw@jabberwocky.com>

	* mpicoder.c (mpi_read): If we must fail due to a oversize
	(generally corrupt) MPI, make sure the number of bytes we read is
	valid so we can skip the rest of the bad packet (in hopes the
	whole stream isn't invalid).

2004-05-20  David Shaw  <dshaw@jabberwocky.com>

	* longlong.h: Typo.

	* mpi-pow.c (mpi_powm): s/exp/exponent/ to shutup a compiler
	warning.  From Werner on stable branch.

2004-01-20  David Shaw  <dshaw@jabberwocky.com>

	* hppa1.1/udiv-qrnnd.S: Alignment fix from Lamont Jones for
	Debian.

2004-01-11  David Shaw  <dshaw@jabberwocky.com>

	* config.links: OpenBSD 3.4 is now ELF, so use the proper
	assembler code for that.  Use the portable C MPI code for OpenBSD
	before 3.4, and remove the special i386-openbsd assembly
	directory.

	* Makefile.am: Add the portable C links to DISTCLEANFILES.  Noted
	by Nelson H. F. Beebe.

	* mpi-mpow.c (build_index): s/index/idx/ to avoid gcc warning.
	From Werner on stable branch.

	* longlong.h: Added PowerPC 64 bit code from GPM-4.1.2 but didn't
	enable it yet.  From Werner on stable branch.

2003-12-29  David Shaw  <dshaw@jabberwocky.com>

	* g10m.c: Dead code.  Remove.

	* Makefile.am: Don't compile g10m.c.

2003-12-17  David Shaw  <dshaw@localhost.localdomain>

	* mpiutil.c (mpi_set_opaque, mpi_get_opaque): Make the length of
	an opaque MPI unsigned.

2003-12-04  David Shaw  <dshaw@jabberwocky.com>

	* config.links: Show target in asm-syntax.h file and include
	targets for K*BSD (GNU userland with BSD kernel).

2003-11-20  David Shaw  <dshaw@jabberwocky.com>

	* config.links: sparc64 assembler doesn't work on FreeBSD or
	OpenBSD either.

2003-05-26  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am: Make use of AM_CFLAGS. (From wk on stable branch)

2003-05-24  David Shaw  <dshaw@jabberwocky.com>

	* mpicoder.c, mpi-inline.h, mpi-inv.c, mpiutil.c, mpih-div.c,
	mpi-internal.h, mpi-scan.c: Edit all preprocessor instructions to
	remove whitespace before the '#'.  This is not required by C89,
	but there are some compilers out there that don't like it.

2003-04-25  David Shaw  <dshaw@jabberwocky.com>

	* config.links: Re-disable assembler on Darwin.  Darwin 6.5 broke
	it again.

2003-04-15  Werner Koch  <wk@gnupg.org>

	* longlong.h (umul_ppmm): Support SH3 and SH4.  Thanks to
	kazuya.s@jp.yokogawa.com.

2002-11-16  David Shaw  <dshaw@jabberwocky.com>

	* config.links: Use OpenBSD/NetBSD powerpc assembler code for
	Darwin.  Successfully tested by Gordon Worley.

2002-10-17  Werner Koch  <wk@gnupg.org>

	* config.links (powerpc-apple-darwin6.1): Disable assembler
	due to non-working modules/as.  Suggested by Gordon Worley.

2002-10-02  David Shaw  <dshaw@jabberwocky.com>

	* longlong.h: Some whitespace changes in HPPA to fix assembler
	problems on HP-UX.  From David Ellement.

2002-09-20  Werner Koch  <wk@gnupg.org>

	* mpicoder.c (do_get_buffer): Avoid zero length allocation.
	Checked that all callers behave properly when NBYTES returns 0 as
	the length of the allocated buffer.

2002-09-10  Werner Koch  <wk@gnupg.org>

	* mpi-bit.c (mpi_normalize): Replaced the check for protected by
	is_opaque.
	(mpi_get_nbits): Removed the special case for protected MPIs.
	* mpicoder.c (do_get_buffer): Likewise.
	(mpi_print): Removed the nbit_info printing.

2002-09-03  Werner Koch  <wk@gnupg.org>

	* mpicoder.c (mpi_set_buffer): Cast all left operands of a shift
	to a larger type so that 16 bit CPUs don't suffer from an
	overflow.  Suggested by TOGAWA Satoshi.

2002-08-24  David Shaw  <dshaw@jabberwocky.com>

	* longlong.h: Remove space between \ and newline. gcc is
	complaining.

2002-08-13  Werner Koch  <wk@gnupg.org>

	* mpicoder.c (do_get_buffer): Don't remove leading zeros if the
	MPI is marked as protected.

2002-08-02  Timo Schulz  <ts@winpt.org>

	* mpicoder.c: Add a '\n' to all log_bug functions.
	
2002-08-01  Werner Koch  <wk@gnupg.org>

	* config.links: Added case for sparc64-netbsd. Suggested by
	ww@styx.org.

2002-07-25  David Shaw  <dshaw@jabberwocky.com>

	* config.links: Add special rule for OpenBSD on x86 to use special
	i386-openbsd files.  OpenBSD (at least until version 3.1) has an
	older assembler that won't work with the files in i386.

2002-07-24  Stefan Bellon  <sbellon@sbellon.de>

	* longlong.h [__riscos__]: Removed #pragma which is not needed
	anymore since the K&R multiline strings are gone.

2002-07-24  Werner Koch  <wk@gnupg.org>

	* longlong.h: Replaced all K&R multiline strings by ISO ones for
	the sake of modern compilers.  Suggested by Marco Parrone.

2002-05-10  Stefan Bellon  <sbellon@sbellon.de>

	* mpiutil.c (mpi_alloc_like/mpi_debug_alloc_like): Added code
	for M_DEBUG.

2002-04-18  Werner Koch  <wk@gnupg.org>

	* i386/syntax.h (ALIGN): Removed parens from definition
	* i386/mpih-add1.S, i386/mpih-sub1.S, i386/mpih-rshift.S,
	i386/mpih-lshift.S: Minor syntax changes suggested by Mark Pettit
	after comparing the files with those for GMP 4.
	
2001-11-08  Werner Koch  <wk@gnupg.org>

	* config.links (mpi_sflags): Add extra rule for sparc64-sun-solaris2.

2001-08-20  Werner Koch  <wk@gnupg.org>

	* longlong.h [__riscos__]: Need a special pragma here.

2001-08-09  Werner Koch  <wk@gnupg.org>

	* config.links: Added configuraton for powerpc-openbsd.  By Peter
	Valchev

2001-07-09  Werner Koch  <wk@gnupg.org>

	* config.links: Changed the way the list of files to be
	symlinked is returned.

2001-05-27  Werner Koch  <wk@gnupg.org>

	* hppa/, hppa1.1/, pa7100/ : Use .label command instead of labels
	because there syntax changed.  By Matthew Wilcox.

2001-05-06  Werner Koch  <wk@gnupg.org>

	* longlong.h: Fixes for ARM by Phil Blundell.

2001-04-17  Werner Koch  <wk@gnupg.org>

	Updated copyright notices.

2001-03-24  Werner Koch  <wk@gnupg.org>

	* mpi-mul.c (mpi_mul): Make sure that secret temporary results are
	not stored in w.  Suggested by Florian Weimer.

2001-03-18  Werner Koch  <wk@gnupg.org>

	* config.links: Use i386 code for i386.  According to tests by
	Kevin Ryde the i586 code runs slow on i386 CPUs.  Ditto for i786.

2000-10-24  Werner Koch  <wk@gnupg.org>

	* mips3/: Changed a few comments to C-style. By Jeff Long.

2000-10-13  Werner Koch  <wk@gnupg.org>

	* mpi.h: Removed the inclusion of mpi-asm-defs.h because this
	makes some trouble when doing a VPATH build.  configure now
	takes care of it.
	
2000-10-12  Werner Koch  <wk@gnupg.org>

	* generic/mpi-asm-defs.h: New.
	* mips3/mpi-asm-defs.h: New.
	* config.links: Create a link to one of the above files.

Wed Jul 19 11:26:43 CEST 2000  Werner Koch  <wk@>

        * config.links: Support for powerpc--netbsd by Gabriel Rosenkoetter.

Wed Mar 22 13:50:24 CET 2000  Werner Koch  <wk@openit.de>

	* config.links: Add support for FreeBSD 5 and made the case stmt
	looking nicer.	From Jun Kuriyama.

Fri Mar 17 17:50:25 CET 2000  Werner Koch  <wk@openit.de>

	* config.links (sparc64-unknown-linux-gnu): use udic module.
	From Adam Mitchell.

2000-03-14 12:03:56  Werner Koch  (wk@habibti.openit.de)

	* Makefile.am: Do not use .s and .S files but a temp names, so that
	OSes with caseinsensitive filenames do work.  From Frank Donahoe.

Tue Mar  7 18:45:31 CET 2000  Werner Koch  <wk@gnupg.de>

	* mpih-mul.c (mpihelp_mul_karatsuba_case): It seems that the
	untested part works fine.  Removed the debugging message.

	* longlong.h (umul_ppmm): Fixes for ARM-4. By Sean MacLennan.

	* config.links: Add support for NetBSD.

Thu Jan 13 19:31:58 CET 2000  Werner Koch  <wk@gnupg.de>

	* mpi-internal.h (karatsuba_ctx): New.
	* mpih-mul.c (mpihelp_release_karatsuba_ctx): New.
	(mpihelp_mul_karatsuba_case): New.
	(mpihelp_mul): Splitted to make use of the new functions.
	* mpi-pow.c (mpi_powm): Make use of the new splitted function
	to avoid multiple allocation of temporary memory during the
	karatsuba operations.

	* mpi_mpow.c: Removed the unused Barrett code.

Sun Dec 19 15:22:26 CET 1999  Werner Koch  <wk@gnupg.de>

	* power/ : Converted more comments to C comments because some AS
	complain about ' in comments.

Thu Dec 16 10:07:58 CET 1999  Werner Koch  <wk@gnupg.de>

	* Makefile.am: c/SFLAGS/ASFLAGS/. This has only been used by the
	powerpc and actually never passed the -Wa,foo to the cc.

Thu Dec  9 10:31:05 CET 1999  Werner Koch  <wk@gnupg.de>

	* power/: Add all files from GMP for this CPU.

	* config.links:  Support for BSDI 4.x. By Wayne Chapeskie.
	(sparc8): Made the search path the same as sparc9

	* mpih-div.c (mpihelp_divrem): The MPN_COPY_DECR copied one
	elemnat too many.  This is gmp2.0.2p9.txt patch.

Sat Oct  9 20:34:41 CEST 1999  Werner Koch  <wk@gnupg.de>

	* Makefile.am:	Removed libtool.

Mon Aug 30 20:38:33 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* config.links: Add case label for DJGPP

Wed Jul 14 19:42:08 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>


	* Makefile.am: Use .s files as temporaries, disabled other .S rules.

Wed Jul  7 13:08:40 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>


	* mpicoder.c (g10_log_mpidump): New.

	* Makefile.am: Support for libtool.

Fri Jul  2 11:45:54 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>


	* mpi-bit.c (mpi_lshift_limbs,mpi_rshift_limbs): New.
	* mpi-mpow.c (barrett_mulm): New but diabled.

Tue Jun  1 16:01:46 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* config.links (i[56]86*-*-freebsdelf*): New.

Sun May 23 14:20:22 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* config.links (sysdep.h): Not any more conditionally created.

Tue May  4 15:47:53 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* mpiutil.c (mpi_alloc_like): New.

Mon Apr 26 17:48:15 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* mpih-add.c, mpih-sub.c: Removed
	* mpi-inline.c: New.
	* mpi-inline.h: Make it usable by mpi-inline.c.

Sun Apr 18 10:11:28 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* mpih-mul.c (mpihelp_mul_n): Fixed use of memory region.
	(mpihelp_mul): Ditto.

Wed Apr  7 20:51:39 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* Makefile.am: Explicit rules to invoke cpp on *.S

Mon Mar  8 20:47:17 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* config.links: Take advantage of the with_symbol_underscore macro.
	Add support for freebsd 4.

Wed Feb 24 11:07:27 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* mips3/mpih-sub1.S: Removed left over junk in last line. (Should I
	blame me or my editor?).

Sat Feb 13 12:04:43 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* Makefile.am: Removed the +=. Add MPI_OPT_FLAGS.

Sat Jan  9 16:02:23 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* mpi-cmp.c (mpi_cmp_ui): Normalized the arg.

Thu Jan  7 18:00:58 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* mpi-bit.c (mpi_normalize): New.
	(mpi_get_nbits): Normalize the MPI.
	* mpi-bit.c (mpi_cmp): Normalize the MPI before the compare.


Tue Dec  8 13:15:16 CET 1998  Werner Koch  <wk@isil.d.shuttle.de>

	* config.links: Moved the case for powerpc*linux
	* powerpcp32/*.S: Removed some underscores.

Thu Nov 26 07:27:52 1998  Werner Koch  <werner.koch@guug.de>

	* config.links: Support for ppc with ELF
	* powerpc32/syntax.h: New.
	* powerpc32/*.S: Applied ELF patches (glibc patches)

Tue Nov 10 19:31:37 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* power*/ : Started with stuff for PPC
	* config.links: Some stuff for PPC.
	* generic/udiv-w-sdiv.c: New but disabled.

Tue Oct 27 12:37:46 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* config.links (freebsd): Fixes for FreeBSD 3.0

Wed Oct 14 09:59:30 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* config.links (freebsd): ELF patches from Jun Kuriyama.

Thu Oct  8 13:28:17 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* mpi-mpow.c (mpi_mulpowm): Fixed mem leak (m_free/mpi_free).

Thu Sep 17 18:08:50 1998  Werner Koch  (wk@(none))

	* hppa1.1/udiv-qrnnd.S: Fix from Steffen Zahn for HPUX 10.20

Thu Aug  6 16:39:28 1998  Werner Koch,mobil,,,	(wk@tobold)

	* mpi-bit.c (mpi_set_bytes): Removed.

Wed Aug  5 15:11:12 1998  Werner Koch  (wk@(none))

	* mpicoder.c (mpi_read_from_buffer): New.

	* mpiutil.c (mpi_set_opaque): New.
	(mpi_get_opaque): New.
	(mpi_copy): Changed to support opauqe flag
	(mpi_free): Ditto.

Sat Jul  4 10:11:11 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* mpiutil.c (mpi_clear): Reset flags.
	(mpi_set): Ditto.
	(mpi_alloc_secure): Set flag to 1 and not ored the 1 in, tsss..

Fri Jun 26 11:19:06 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* mpiutil.c (mpi_alloc): set nbits to 0.
	(mpi_alloc_secure): Ditto.
	(mpi_clear): Ditto.

Thu Jun 25 11:50:01 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* mips3/*.S: New

Mon May 18 13:47:06 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* config.links: split mpih-shift into mpih-[lr]shift and
	changed all implementations.
	* mpi/alpha: add some new assembler stuff.

Wed May 13 11:04:29 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* config.links: Add support for MIPS

Thu Apr  9 11:31:36 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* mpicoder.c (mpi_get_secure_buffer): New.

Wed Apr  8 09:44:33 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* config.links: Applied small fix from Ulf Möller.

Mon Apr  6 12:38:52 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* mpicoder.c (mpi_get_buffer): Removed returned leading zeroes
	and changed all callers.

Tue Mar 10 13:40:34 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* mpi-bit.c (mpi_clear_highbit): New.

Mon Mar  2 19:29:00 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* Makefile.am (DISTCLEANFILES): New

Thu Feb 26 06:48:54 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* config.links (X86_BROKEN_ALIGN): Added for some systems.

Mon Feb 23 12:21:40 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* mpi/m68k/mpih-shift.S (Lspecial): Changed duplicate symbol.

Mon Feb 16 13:00:27 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* config.links : Add detection of m68k cpus



 Copyright 1998, 1999, 2000, 2001 Free Software Foundation, Inc.

 This file is free software; as a special exception the author gives
 unlimited permission to copy and/or distribute it, with or without
 modifications, as long as this notice is preserved.

 This file is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.


